
zk.BigDecimal = zk.$extends(zk.Object, {
	_precision: 0,
	$define: {
		precision: null
	},
	$init: function (value) {
		value = value ? '' + value: '0';
		var j = value.lastIndexOf('.');
		if (j >= 0) {
			value = value.substring(0, j) + value.substring(j + 1);
			this._precision = value.length - j;
			this._dot = true;
		}
		this._value = value;
	},
	$toString: function() { //toString is reserved keyword for IE
		var j = this._value.length - this._precision;
		return this._value.substring(0, j) + (this._dot ? '.' + this._value.substring(j) : '');
	},
	$toLocaleString: function() { //toLocaleString is reserved keyword for IE
		var j = this._value.length - this._precision;
		return this._value.substring(0, j) + (this._precision ? zk.DECIMAL + this._value.substring(j) : '');
	}
});
